"use strict";
exports.__esModule = true;
exports.comparer = void 0;
/**
 * Gets the value of a table cell
 */
var getCellValue = function (row, index) {
    var attribute = row.querySelector("td:nth-child(".concat(index + 1, ")")).getAttribute('data-raw');
    return attribute !== undefined ? attribute : row.querySelector("td:nth-child(".concat(index + 1, ")")).textContent;
};
/**
 * Compares cell values (table sort)
 */
var comparer = function (index) {
    return function (a, b) {
        var valA = getCellValue(a, index), valB = getCellValue(b, index);
        return !isNaN(parseFloat(valA)) && isFinite(valA) &&
            !isNaN(parseFloat(valB)) && isFinite(valB)
            ? valA - valB
            : valA.localeCompare(valB);
    };
};
exports.comparer = comparer;
//# sourceMappingURL=comparer.js.map