"use strict";
exports.__esModule = true;
exports.debounce = void 0;
/**
 * Debounce function for quick-firing events like window resize
 */
var debounce = function (f) {
    var timer = null;
    return function (e) {
        if (timer) {
            clearTimeout(timer);
        }
        timer = window.setTimeout(f, 100, e);
    };
};
exports.debounce = debounce;
//# sourceMappingURL=debounce.js.map