"use strict";
exports.__esModule = true;
exports.generateWget = void 0;
/**
 * Scans the table for available extensions, then
 * generates a `wget` command to download them specifically
 */
var generateWget = function (table) {
    var url = window.location.href;
    var extensions = [];
    table.querySelectorAll('tr.file:not(.filtered) > td:first-child > a').forEach(function (element) {
        var extension = element.textContent.split('.').pop().toLowerCase().trim();
        if (!extensions.includes(extension))
            extensions.push(extension);
    });
    return "wget -r -np -nH -nd -e robots=off --accept \"".concat(extensions.join(','), "\" \"").concat(url, "\"");
};
exports.generateWget = generateWget;
//# sourceMappingURL=generateWget.js.map