"use strict";
exports.__esModule = true;
exports.clickablePath = void 0;
var index_1 = require("../index");
/**
 * Creates a clickable path (using anchors) from a path string
 */
var clickablePath = function (p) {
    var parts = (0, index_1.trimBoth)(p, '/').split('/');
    var built = '<a href="/">/</a>';
    parts.forEach(function (part, index) {
        if (part.length > 0) {
            /** Create anchor href */
            var href = parts.slice(0, index + 1).join('/') + '/';
            built = (built + "<a href=\"/".concat(href, "\">").concat(((index + 1) !== 1 ? '/' : '')).concat(
            /** Adds a trailing slash to the last index */
            part + (index === (parts.length - 1) ? '/' : ''), "</a>"));
        }
    });
    return built;
};
exports.clickablePath = clickablePath;
//# sourceMappingURL=clickablePath.js.map