"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.mergeExisting = void 0;
var lodash_1 = __importDefault(require("lodash"));
/**
 * Merges an object without adding non-existant keys to the destination object
 */
exports.mergeExisting = {
    keepShapeArray: function (destination, source) {
        if (source.length != destination.length) {
            return destination;
        }
        var r = [];
        destination.forEach(function (v, i) {
            r[i] = exports.mergeExisting.keepShape(v, source[i]);
        });
        return r;
    },
    keepShapeObject: function (destination, source) {
        var r = {};
        Object.keys(destination).forEach(function (key) {
            var sourceValue = source[key];
            if (typeof sourceValue !== 'undefined') {
                r[key] = exports.mergeExisting.keepShape(destination[key], sourceValue);
            }
            else {
                r[key] = destination[key];
            }
        });
        return r;
    },
    keepShape: function (destination, source) {
        if (lodash_1["default"].isArray(destination)) {
            if (!lodash_1["default"].isArray(source)) {
                return destination;
            }
            return exports.mergeExisting.keepShapeArray(destination, source);
        }
        else if (lodash_1["default"].isObject(destination)) {
            if (!lodash_1["default"].isObject(source)) {
                return destination;
            }
            return exports.mergeExisting.keepShapeObject(destination, source);
        }
        else {
            return source;
        }
    }
};
//# sourceMappingURL=mergeExisting.js.map