"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
exports.__esModule = true;
exports.mergeMetadata = void 0;
/**
 * Merges a metadata array with another metadata array
 */
var mergeMetadata = function (source, data) {
    var metadata = {};
    /** Iterate over and store current metadata */
    for (var _i = 0, source_1 = source; _i < source_1.length; _i++) {
        var item = source_1[_i];
        for (var _a = 0, _b = Object.entries(item); _a < _b.length; _a++) {
            var _c = _b[_a], key = _c[0], value = _c[1];
            if (key !== 'content') {
                /** Reset object if no content is present, or create on unexisting key */
                if (item.content === false
                    || !Object.prototype.hasOwnProperty.call(metadata, key)) {
                    metadata[key] = {};
                }
                metadata[key][value] = item.content || false;
            }
        }
    }
    /** Iterate over new metadata, overwrite when needed */
    for (var _d = 0, data_1 = data; _d < data_1.length; _d++) {
        var _e = data_1[_d];
        var _f = _e.content, content = _f === void 0 ? false : _f, rest = __rest(_e, ["content"]);
        for (var _g = 0, _h = Object.entries(rest); _g < _h.length; _g++) {
            var _j = _h[_g], key = _j[0], value = _j[1];
            if (key !== 'content') {
                /** Reset object if no content is present, or create on unexisting key */
                if (content === false
                    || !Object.prototype.hasOwnProperty.call(metadata, key)) {
                    metadata[key] = {};
                }
                metadata[key][value] = content || false;
            }
        }
    }
    /** Create and return metadata array */
    return Object.entries(metadata).flatMap(function (_a) {
        var property = _a[0], values = _a[1];
        return Object.entries(values).map(function (_a) {
            var _b;
            var key = _a[0], content = _a[1];
            return (__assign((_b = {}, _b[property] = key, _b), (content && { content: content })));
        });
    });
};
exports.mergeMetadata = mergeMetadata;
//# sourceMappingURL=mergeMetadata.js.map