"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.sortByKey = void 0;
var lodash_1 = __importDefault(require("lodash"));
var index_1 = require("../index");
/**
 * Sorts an object by a key
 */
var sortByKey = function (obj, path, order) {
    if (order === void 0) { order = 'asc'; }
    var ascending = (order === 'asc');
    return obj.sort(function (a, b) {
        var value = {
            a: lodash_1["default"].get(a, path),
            b: lodash_1["default"].get(b, path)
        };
        return (0, index_1.isNumeric)(value.a) && (0, index_1.isNumeric)(value.b)
            ? (ascending)
                ? (value.a - value.b)
                : (value.b - value.a)
            : (ascending)
                ? (value.a).localeCompare(value.b)
                : (value.b).localeCompare(value.a);
    });
};
exports.sortByKey = sortByKey;
//# sourceMappingURL=sortByKey.js.map