"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.loadThemes = void 0;
var path_1 = __importDefault(require("path"));
var chalk_1 = __importDefault(require("chalk"));
var fs_1 = require("fs");
var index_1 = require("./index");
var index_2 = require("../index");
;
/**
 * Loads themes from a path into a pool (object containing paths and named keys)
 */
var loadThemes = function (location) { return __awaiter(void 0, void 0, void 0, function () {
    var pool, _a, error_1;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                pool = {
                    "default": {
                        path: null
                    }
                };
                _b.label = 1;
            case 1:
                _b.trys.push([1, 4, , 5]);
                _a = index_1.asyncForEach;
                return [4 /*yield*/, (0, index_1.dirScan)(location)];
            case 2: return [4 /*yield*/, _a.apply(void 0, [_b.sent(), function (file) { return __awaiter(void 0, void 0, void 0, function () {
                        var rootName, extension, stat, themeDir;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    rootName = file.basename, extension = file.extension;
                                    return [4 /*yield*/, fs_1.promises.lstat(path_1["default"].join(location, rootName))];
                                case 1:
                                    stat = _a.sent();
                                    if (!(stat.isFile() && (extension).toLowerCase() === 'css')) return [3 /*break*/, 2];
                                    /** Add a single stylesheet to the pool */
                                    pool[(0, index_2.stripExtension)(rootName).toLowerCase()] = {
                                        path: path_1["default"].join('/themes/', rootName)
                                    };
                                    return [3 /*break*/, 4];
                                case 2:
                                    if (!stat.isDirectory()) return [3 /*break*/, 4];
                                    themeDir = path_1["default"].join(location, rootName);
                                    return [4 /*yield*/, (0, index_1.dirScan)(themeDir, {
                                            include: ['css']
                                        })];
                                case 3:
                                    /** Child is a directory, scan it for stylesheets */
                                    (_a.sent()).map(function (file) {
                                        var childName = file.basename;
                                        /** Directory is a theme directory, add stylesheet to pool */
                                        pool[(0, index_2.stripExtension)(childName).toLowerCase()] = {
                                            path: path_1["default"].join('/themes/', rootName, childName)
                                        };
                                    });
                                    _a.label = 4;
                                case 4: return [2 /*return*/];
                            }
                        });
                    }); }])];
            case 3:
                _b.sent();
                return [2 /*return*/, Object.keys(pool).length === 1 ? null : pool];
            case 4:
                error_1 = _b.sent();
                (0, index_1.logger)('error', 'Loading themes failed', chalk_1["default"].red(error_1));
                return [2 /*return*/, null];
            case 5: return [2 /*return*/];
        }
    });
}); };
exports.loadThemes = loadThemes;
//# sourceMappingURL=themeLoader.js.map