"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.options = void 0;
/** Vendors */
var lodash_1 = __importDefault(require("lodash"));
var data = {
    processor: null,
    format: {
        sizes: [' B', ' KiB', ' MiB', ' GiB', ' TiB'],
        date: ['d/m/y H:i', 'd/m/y']
    },
    sorting: {
        enabled: false,
        types: 0,
        sortBy: 'name',
        ascending: 1
    },
    gallery: {
        enabled: true,
        reverseOptions: false,
        scrollInterval: 50,
        listAlignment: 0,
        fitContent: true
    },
    preview: {
        enabled: true,
        hoverDelay: 75,
        cursorIndicator: true
    },
    readme: {
        enabled: true,
        hidden: false,
        toggled: true
    },
    media: {
        extensions: {
            image: ['jpg', 'jpeg', 'png', 'gif', 'ico', 'svg', 'bmp', 'webp'],
            video: ['webm', 'mp4', 'ogv', 'ogg', 'mov']
        }
    },
    style: {
        themes: false,
        compact: false
    },
    icon: {
        path: null,
        mime: 'image/png'
    },
    performance: 100,
    exclude: false,
    debug: false
};
var options = {
    set: function (object) {
        return lodash_1["default"].mergeWith(data, object, function (a, b) {
            return lodash_1["default"].isArray(b) ? b : undefined;
        });
    },
    insert: function (path, value) {
        return lodash_1["default"].set(data, path, value);
    },
    get: function (path, fallback) {
        if (path === void 0) { path = null; }
        if (fallback === void 0) { fallback = null; }
        return lodash_1["default"].get(data, path, !fallback ? data : fallback);
    }
};
exports.options = options;
//# sourceMappingURL=options.js.map